IncludeFile "HDD_Families.pb"

Structure DeviceData
	GeneralConfiguration.w;				; 0
	LogicalCylinders.w;					; 1	Obsolete
	SpecificConfiguration.w;				; 2
	LogicalHeads.w;						; 3 Obsolete
	Retired1.w[2];						; 4-5
	LogicalSectors.w;						; 6 Obsolete
	ReservedForCompactFlash.l;			; 7-8
	Retired2.w;							; 9
	SerialNumber.c[20];					; 10-19
	Retired3.w;							; 20
	BufferSize.w;							; 21 Obsolete
	ECCSize.w;							; 22
	FirmwareRev.c[8];						; 23-26
	ModelNumber.c[40];							; 27-46
	MaxNumPerInterupt.w;					; 47
	Reserved1.w;							; 48
	Capabilities1.w;						; 49
	Capabilities2.w;						; 50
	Obsolute5.l;							; 51-52
	Field88and7064.w;						; 53
	Obsolute6.w[5];						; 54-58
	MultSectorStuff.w;					; 59
	TotalAddressableSectors.l;			; 60-61
	Obsolute7.w;							; 62
	MultiWordDma.w;						; 63
	PioMode.w;							; 64
	MinMultiwordDmaCycleTime.w;			; 65
	RecommendedMultiwordDmaCycleTime.w;	; 66
	MinPioCycleTimewoFlowCtrl.w;			; 67
	MinPioCycleTimeWithFlowCtrl.w;		; 68
	Reserved2.w[6];						; 69-74
	QueueDepth.w;							; 75
	SerialAtaCapabilities.w;				; 76
	ReservedForFutureSerialAta.w;			; 77
	SerialAtaFeaturesSupported.w;			; 78
	SerialAtaFeaturesEnabled.w;			; 79
	MajorVersion.w;						; 80
	MinorVersion.w;						; 81
	CommandSetSupported1.w;				; 82
	CommandSetSupported2.w;				; 83
	CommandSetSupported3.w;				; 84
	CommandSetEnabled1.w;					; 85
	CommandSetEnabled2.w;					; 86
	CommandSetDefault.w;					; 87
	UltraDmaMode.w;						; 88
	TimeReqForSecurityErase.w;			; 89
	TimeReqForEnhancedSecure.w;			; 90
	CurrentPowerManagement.w;				; 91
	MasterPasswordRevision.w;				; 92
	HardwareResetResult.w;				; 93
	Acoustricmanagement.w;				; 94
	StreamMinRequestSize.w;				; 95
	StreamingTimeDma.w;					; 96
	StreamingAccessLatency.w;				; 97
	StreamingPerformance.l;				; 98-99
	MaxUserLba.q;							; 100-103
	StremingTimePio.w;					; 104
	Reserved3.w;							; 105
	SectorSize.w;							; 106
	InterSeekDelay.w;						; 107
	IeeeOui.w;							; 108
	UniqueId3.w;							; 109
	UniqueId2.w;							; 110
	UniqueId1.w;							; 111
	Reserved4.w[4];						; 112-115
	Reserved5.w;							; 116
	WordsPerLogicalSector.l;				; 117-118
	Reserved6.w[8];						; 119-126
	RemovableMediaStatus.w;				; 127
	SecurityStatus.w;						; 128
	VendorSpecific.w[31];					; 129-159
	CfaPowerMode1.w;						; 160
	Reserved7.w[15];						; 161-175
	CurrentMediaSerialNo.c[60];			; 176-205
	SctCommandTransport.w;				; 206  254
	ReservedForCeAta1.w[2];				; 207-208
	AlignmentOfLogicalBlocks.w;			; 209
	WriteReadVerifySectorCountMode3.l;	; 210-211
	WriteReadVerifySectorCountMode2.l;	; 212-213
	NvCacheCapabilities.w;				; 214
	NvCacheSizeLogicalBlocks.l;			; 215-216
	NominalMediaRotationRate.w;			; 217
	Reserved8.w;							; 218
	NvCacheOptions1.w;					; 219
	NvCacheOptions2.w;					; 220
	Reserved9.w;							; 221
	TransportMajorVersionNumber.w;		; 222
	TransportMinorVersionNumber.w;		; 223
	ReservedForCeAta2.w[10];				; 224-233
	MinimumBlocksPerDownloadMicrocode.w;	; 234
	MaximumBlocksPerDownloadMicrocode.w;	; 235
	Reserved10.w[19];						; 236-254
	IntegrityWord.w;						; 255
EndStructure

Structure IDEREGS 
    bFeaturesReg.b 
    bSectorCountReg.b 
    bSectorNumberReg.b 
    bCylLowReg.b 
    bCylHighReg.b 
    bDriveHeadReg.b 
    bCommandReg.b 
    bReserved.b 
EndStructure 
Structure SENDCMDINPARAMS 
    cBufferSize.l 
    irDriveRegs.IDEREGS 
    bDriveNumber.b 
    bReserved.b[3] 
    dwReserved.l[4]
EndStructure 

Structure  DRIVERSTATUS 
    bDriveError.b 
    bIDEStatus.b 
    bReserved.b[2]
    dwReserved.l[2]
EndStructure 
Structure  SENDCMDOUTPARAMS 
    cBufferSize.l 
    DStatus.DRIVERSTATUS      
    bBuffer.b[512]
EndStructure

Structure SupportedFlags
	SMART.s
	LBA48.s
	AAM.s
	NCQ.s
	NVCache.s
EndStructure

Structure SRB_IO_CONTROL
	HeaderLength.l
	Signature.b[8]
	Timeout.l
	ControlCode.l
	ReturnCode.l
	Length.l
EndStructure

Structure AttrData
   AttrID.c
   AttrName.s
   AttrValue.c
   AttrWorstValue.c
   AttrThreshold.c
   AttrRaw.q
   StatusFlags.w
EndStructure
Structure DriveInfo
	SerialNumber.s
	Model.s
	Family.s
	FirmWare.s
	BufferSize.s
	ECCBytes.s
	LBASectors.s
	CurTransferMode.s
	MaxTransferMode.s
	InterfaceType.s
	Standard.s
	Flags.SupportedFlags
	NumAttributes.l
	Attributes.AttrData[31]
	Temperature.s
	TheoriticalCapacity.s
	RealCapacity.s
	DiskStatus.s
EndStructure

#DFP_RECEIVE_DRIVE_DATA = $7C088
#DFP_SEND_DRIVE_COMMAND	= $7C084
#IOCTL_SCSI_MINIPORT    = $4D008
#IOCTL_SCSI_MINIPORT_ENABLE_SMART = $1B0504
#SCSI_MINIPORT_BUFFER_SIZE = 512

Global idsec.DeviceData
Global Dim di.DriveInfo(1)
Global hdh.l
Global HDDCount.l = -1
Global ATAVersion.l
Global bin.SENDCMDINPARAMS
Global bout.SENDCMDOUTPARAMS

Procedure.s ChangeHighLowByte(Instring.s) 
  ;Change BIG-Little Endian 
  sdummy.s="" 
  L=Len(Instring) 
  For I=1 To L Step 2 
  If (I+1)<=L 
    sdummy = sdummy + Mid(Instring,I+1,1)+Mid(Instring,I,1)  
  EndIf 
  Next I 
  ProcedureReturn sdummy
EndProcedure

Declare ReadAttributes(CurrentDrive.l, SCSITargetID.l)
Declare ReadThresholds(CurrentDrive.l, SCSITargetID.l)

Procedure.s FormatByteSize(n.q)
  Protected s.s=StrQ(n)
  Protected len=Len(s)
  Protected ret.s
 
  For i=0 To len-1
    If i And Not i%3 : ret="." + ret : EndIf; "." is the greek symbol for separating thousands. Use your own.
    ret= Mid(s,len-i,1) +ret
  Next
 
  ProcedureReturn ret
EndProcedure

Procedure.s c2str(num.d, demical.l=0)
;This procedure is used to change the english "." demical separator to the greek ",".
;Use yor own symbol is you want.
ProcedureReturn ReplaceString(StrD(num,demical), ".", ",")
EndProcedure

Procedure OpenSmart(CurrentDrive.l, SCSIPort.l)
If CurrentDrive >= 0; ATA
	Select OSVersion()
		Case #PB_OS_Windows_95, #PB_OS_Windows_98, #PB_OS_Windows_ME
			hdh = CreateFile_("\\.\SMARTVSD.VXD", 0, 0, 0, #CREATE_NEW, 0, 0)
		Default
			hdh = CreateFile_("\\.\PhysicalDrive" + Str(CurrentDrive),#GENERIC_READ | #GENERIC_WRITE, #FILE_SHARE_READ | #FILE_SHARE_WRITE,0, #OPEN_EXISTING, 0, 0) 
	EndSelect
Else; SCSI
	hdh = CreateFile_("\\.\Scsi" + Str(SCSIPort) + ":", #GENERIC_READ | #GENERIC_WRITE, #FILE_SHARE_READ | #FILE_SHARE_WRITE, #Null, #OPEN_EXISTING, 0, #Null)
EndIf
EndProcedure

Procedure.s GetAttributeName(AttribID.l)
Select AttribID
	Case 0
		ProcedureReturn "Invalid Attribute"
	Case 1
		ProcedureReturn "Raw Read Error Rate"
	Case 2
		ProcedureReturn "ThroughPut Performance"
	Case 3
		ProcedureReturn "Spin Up Time"
	Case 4
		ProcedureReturn "Start/Stop Count"
	Case 5
		ProcedureReturn "Reallocated Sector Count"
	Case 6
		ProcedureReturn "Read Channel Margin"
	Case 7
		ProcedureReturn "Seek Error Rate"
	Case 8
		ProcedureReturn "Seek Time Performance"
	Case 9
		ProcedureReturn "Power On Hours Count"
	Case 10
		ProcedureReturn "Spin Retry Count"
	Case 11
		ProcedureReturn "Calibration Retry Count"
	Case 12
		ProcedureReturn "Power Cycle Count"
	Case 13
		ProcedureReturn "Soft Read Error Rate"
	Case 189
		ProcedureReturn "High Fly Writes (WDC)"
	Case 190
		If FindString(di(HDDCount)\Model,"Seagate",1) > 0 
			ProcedureReturn "Temperature Difference from 100"
		Else
			ProcedureReturn "Airflow Temperature (WDC)"
		EndIf
	Case 191
		ProcedureReturn "G Sense Error Rate"
	Case 192
		ProcedureReturn "Power Off Retract Cycle"
	Case 193
		ProcedureReturn "Load/Unload Cycle Count"
	Case 194
		ProcedureReturn "Temperature"
	Case 195
		ProcedureReturn "Hardware ECC Recovered"
	Case 196
		ProcedureReturn "Reallocation Events Count"
	Case 197
		ProcedureReturn "Current Pending Sector Count"
	Case 198
		ProcedureReturn "Uncorrectable Sector Count"
	Case 199
		ProcedureReturn "Ultra DMA CRC Error Rate"
	Case 200
		ProcedureReturn "Write Error Rate / Multi-Zone Error Rate"
	Case 201
		ProcedureReturn "Soft Read Error Rate"
	Case 202
		ProcedureReturn "Data Address Mark errors"
	Case 203
		ProcedureReturn "Run Out Cancel"
	Case 204
		ProcedureReturn "Soft ECC Correction"
	Case 205
		ProcedureReturn "Thermal Asperity Rate"
	Case 206
		ProcedureReturn "Flying Height"
	Case 207
		ProcedureReturn "Spin High Current"
	Case 208
		ProcedureReturn "Spin Buzz"
	Case 209
		ProcedureReturn "Offline Seek Performance"
	Case 211
		ProcedureReturn "Vibration During Write"
	Case 212
		ProcedureReturn "Shock During Write"
	Case 220
		ProcedureReturn "Disk Shift"
	Case 221
		ProcedureReturn "G Sense Error Rate II"
	Case 222
		ProcedureReturn "Loaded Hours"
	Case 223
		ProcedureReturn "Load/Unload Retry Count"
	Case 224
		ProcedureReturn "Load Friction"
	Case 225
		ProcedureReturn "Load/Unload Cycle Count II"
	Case 226
		ProcedureReturn "Load In Time"
	Case 227
		ProcedureReturn "Torque Amplification Count"
	Case 228
		ProcedureReturn "Power Off Retract Count"
	Case 230
		ProcedureReturn "GMR Head Amplitude"
	Case 231
		ProcedureReturn "Temperature II"
	Case 240
		ProcedureReturn "Head Flying Hours"
	Case 250
		ProcedureReturn "Read Error Retry Rate"
	Default 
		ProcedureReturn "Unknown value  ( " + Str(AttribID) + " )"
EndSelect
EndProcedure

Procedure.l CheckSmartEnabled(CurrentDrive.l,SCSIPort.l, SCSITargetID.l)
lBytesReturned.l=0
OpenSmart(CurrentDrive, SCSIPort)
If hdh
	If CurrentDrive >= 0
		With bin
		\irDriveRegs\bFeaturesReg = $D8;SMART_ENABLE_SMART_OPERATIONS
		\irDriveRegs\bSectorCountReg = 1
		\irDriveRegs\bSectorNumberReg = 1
		\irDriveRegs\bCylLowReg = $4F;SMART_CYL_LOW
		\irDriveRegs\bCylHighReg = $C2;SMART_CYL_HI
		\irDriveRegs\bCommandReg = $B0;IDE_EXECUTE_SMART_FUNCTION
		
			\bDriveNumber = CurrentDrive
			\cBufferSize = 0
			If (CurrentDrive & 1)
				\irDriveRegs\bDriveHeadReg = $B0
			Else
				\irDriveRegs\bDriveHeadReg = $A0
			EndIf
		EndWith
		ProcedureReturn DeviceIoControl_(hdh, #DFP_SEND_DRIVE_COMMAND, @bin, SizeOf(SENDCMDINPARAMS), @bout, SizeOf(SENDCMDOUTPARAMS), @lBytesReturned, 0)
	Else
		Dim buffer.b(SizeOf(SRB_IO_CONTROL) + SizeOf(SENDCMDOUTPARAMS) + #SCSI_MINIPORT_BUFFER_SIZE)
		*p.SRB_IO_CONTROL      = @buffer()
		*pin.SENDCMDINPARAMS   = @buffer() + SizeOf(SRB_IO_CONTROL)
		*pout.SENDCMDOUTPARAMS = *pin
		With *p
			\HeaderLength = SizeOf(SRB_IO_CONTROL)
			\Timeout = 2
			\Length = SizeOf(SENDCMDOUTPARAMS) + #SCSI_MINIPORT_BUFFER_SIZE
			;If command = #DISABLE_SMART
			;	\ControlCode = #IOCTL_SCSI_MINIPORT_DISABLE_SMART
			;Else
				\ControlCode = #IOCTL_SCSI_MINIPORT_ENABLE_SMART
			;EndIf
			CopyMemory(@"SCSIDISK", @\Signature, 8)
			;\Signature = "SCSIDISK"
		EndWith
		With *pin
			\irDriveRegs\bFeaturesReg	= $d8;command
			\irDriveRegs\bSectorCountReg	= 1
			\irDriveRegs\bSectorNumberReg	= 1
			\irDriveRegs\bCylLowReg		= $4f;#SMART_CYL_LOW
			\irDriveRegs\bCylHighReg	= $c2;#SMART_CYL_HI
			\irDriveRegs\bCommandReg	= $b0;#SMART_CMD
			\cBufferSize			= #SCSI_MINIPORT_BUFFER_SIZE
			\bDriveNumber			= SCSITargetID
		EndWith
		ProcedureReturn DeviceIoControl_(hdh, #IOCTL_SCSI_MINIPORT, @buffer(), SizeOf(SRB_IO_CONTROL) + SizeOf(SENDCMDINPARAMS) - 1, @buffer(), SizeOf(SRB_IO_CONTROL) + SizeOf(SENDCMDOUTPARAMS) + #SCSI_MINIPORT_BUFFER_SIZE, @dummy.l, #Null)
	EndIf
EndIf
ProcedureReturn 0
EndProcedure

Procedure.s MaximumTransferMode()
;max value
Max.s
If (idsec\UltraDmaMode & $40)
	Max = "Ultra DMA 133 (Mode 6)"
ElseIf (idsec\UltraDmaMode & $20)
	Max = "Ultra DMA 100 (Mode 5)"
ElseIf (idsec\UltraDmaMode & $10)
	Max = "Ultra DMA 66 (Mode 4)"
ElseIf (idsec\UltraDmaMode & 8)
	Max = "Ultra DMA 44(Mode 3)"
ElseIf (idsec\UltraDmaMode & 4)
	Max = "Ultra DMA 33 (Mode 2)"
ElseIf (idsec\UltraDmaMode & 2)
	Max = "Ultra DMA 25 (Mode 1)"
ElseIf (idsec\UltraDmaMode & 1)
	Max = "Ultra DMA 16 (Mode 0)"
EndIf
If idsec\SerialAtaCapabilities & 8
	Max = "SATA 600"
ElseIf idsec\SerialAtaCapabilities & 4
	Max = "SATA 300"
ElseIf idsec\SerialAtaCapabilities & 2
	Max = "SATA 150"
EndIf
ProcedureReturn Max
EndProcedure

Procedure.s CurrentTransferMode()
;current value
cur.s
If (idsec\UltraDmaMode & $4000)
	Cur = "Ultra DMA 133 (Mode 6)"
ElseIf (idsec\UltraDmaMode & $2000)
	Cur = "Ultra DMA 100 (Mode 5)"
ElseIf (idsec\UltraDmaMode & $1000)
	Cur = "Ultra DMA 66 (Mode 4)"
ElseIf (idsec\UltraDmaMode & 800)
	Cur = "Ultra DMA 44(Mode 3)"
ElseIf (idsec\UltraDmaMode & 400)
	Cur = "Ultra DMA 33 (Mode 2)"
ElseIf (idsec\UltraDmaMode & 200)
	Cur = "Ultra DMA 25 (Mode 1)"
ElseIf (idsec\UltraDmaMode & 100)
	Cur = "Ultra DMA 16 (Mode 0)"
EndIf
;If Cur ="";SATA
If idsec\SerialAtaCapabilities & 8
	Cur = "SATA 600"
ElseIf idsec\SerialAtaCapabilities & 4
	Cur = "SATA 300"
ElseIf idsec\SerialAtaCapabilities & 2
	Cur = "SATA 150"
EndIf
;EndIf
If Cur = "": Cur = "Unknown": EndIf
ProcedureReturn Cur
EndProcedure

Procedure.s GetATAMajorVersion()
If idsec\MajorVersion<>0 And idsec\MajorVersion<> $FFFF
	For i.l=14 To 1 Step -1
		If (idsec\MajorVersion >> i) & 1
			ATAVersion = i
			Break
		EndIf
	Next
	If i>=8
		ProcedureReturn "ATA" + Str(i) + "-ACS"
	ElseIf i>=4
		ProcedureReturn "ATA/ATAPI-" + Str(i)
	ElseIf i=0
		ProcedureReturn "Unknown"
	Else
		ProcedureReturn "ATA-" + Str(i)
	EndIf
EndIf
ProcedureReturn "Unknown"
EndProcedure

Procedure ReadAttributes(CurrentDrive.l, SCSITargetID.l)
   cbBytesReturned.l
   Dim bArrOut.c(527)
   If CurrentDrive >= 0
	   With bin
			\cBufferSize = 512;READ_ATTRIBUTE_BUFFER_SIZE
	       \irDriveRegs\bFeaturesReg = $D0;SMART_READ_ATTRIBUTE_VALUES
	       \irDriveRegs\bSectorCountReg = 1
	       \irDriveRegs\bSectorNumberReg = 1
	       \irDriveRegs\bCylLowReg = $4F;SMART_CYL_LOW
	       \irDriveRegs\bCylHighReg = $C2;SMART_CYL_HI
	       \irDriveRegs\bDriveHeadReg = $A0
	       ;If Not IsWindowsNT Then .bDriveHeadReg = .bDriveHeadReg Or (DriveNum And 1) * 16
	       \irDriveRegs\bCommandReg = $B0;IDE_EXECUTE_SMART_FUNCTION
	       
	       \bDriveNumber = CurrentDrive
       EndWith
       ReadAttributesCmd = DeviceIoControl_(hdh, #DFP_RECEIVE_DRIVE_DATA, @bin, SizeOf(SENDCMDINPARAMS), @bArrOut(), 528, @cbBytesReturned, 0)
	Else
		Dim buffer.b(SizeOf(SRB_IO_CONTROL) + SizeOf(SENDCMDOUTPARAMS) + #SCSI_MINIPORT_BUFFER_SIZE)
		*p.SRB_IO_CONTROL      = @buffer()
		*pin.SENDCMDINPARAMS   = @buffer() + SizeOf(SRB_IO_CONTROL)
		*pout.SENDCMDOUTPARAMS = *pin
		
		With *p
			\HeaderLength = SizeOf(SRB_IO_CONTROL)
			\Timeout = 2
			\Length = SizeOf(SENDCMDOUTPARAMS) + #SCSI_MINIPORT_BUFFER_SIZE
			\ControlCode = $1b0502;#IOCTL_SCSI_MINIPORT_ENABLE_SMART
			CopyMemory(@"SCSIDISK", @\Signature, 8)
		EndWith
		With *pin
			\irDriveRegs\bFeaturesReg	= $d0;command
			\irDriveRegs\bSectorCountReg	= 1
			\irDriveRegs\bSectorNumberReg	= 1
			\irDriveRegs\bCylLowReg		= $4f;#SMART_CYL_LOW
			\irDriveRegs\bCylHighReg	= $c2;#SMART_CYL_HI
			\irDriveRegs\bCommandReg	= $b0;#SMART_CMD
			\cBufferSize			= #SCSI_MINIPORT_BUFFER_SIZE
			\bDriveNumber			= SCSITargetID
		EndWith
		bRet = DeviceIoControl_(hdh, #IOCTL_SCSI_MINIPORT, @buffer(), SizeOf(SRB_IO_CONTROL) + SizeOf(SENDCMDINPARAMS) - 1, @buffer(), SizeOf(SRB_IO_CONTROL) + SizeOf(SENDCMDOUTPARAMS) + #SCSI_MINIPORT_BUFFER_SIZE, @dummy.l, #Null)
		CopyMemory(@buffer() + SizeOf(SRB_IO_CONTROL),@bArrOut(), SizeOf(SENDCMDOUTPARAMS))
	EndIf 
	For i = 0 To 29
		If bArrOut(18 + i * 12) > 0
			di(HDDCount)\Attributes[i]\AttrID = bArrOut(18 + i * 12)
         di(HDDCount)\Attributes[i]\AttrName = GetAttributeName(bArrOut(18 + i * 12))
         CopyMemory(@bArrOut(23 + i * 12), @di(HDDCount)\Attributes[i]\AttrRaw, 6)
         di(HDDCount)\Attributes[i]\AttrValue = bArrOut(21 + i * 12)
         di(HDDCount)\Attributes[i]\AttrWorstValue = bArrOut(22 + i * 12)
         If bArrOut(18 + i * 12) = $C2; Temperature
         	di(HDDCount)\Temperature = Str(di(HDDCount)\Attributes[i]\AttrRaw & $FF) + " " +Chr(176)+"C"
         EndIf
         di(HDDCount)\NumAttributes + 1
      EndIf
  Next
EndProcedure

Procedure ReadThresholds(CurrentDrive.l, SCSITargetID.l)
	cbBytesReturned.l
	Dim bArrOut.c(527)
	If CurrentDrive >= 0
	  	With bin
			\cBufferSize = 512;READ_ATTRIBUTE_BUFFER_SIZE
			\irDriveRegs\bFeaturesReg = $D1;SMART_READ_ATTRIBUTE_THRESHOLDS
			\irDriveRegs\bSectorCountReg = 1
			\irDriveRegs\bSectorNumberReg = 1
			\irDriveRegs\bCylLowReg = $4F;SMART_CYL_LOW
			\irDriveRegs\bCylHighReg = $C2;SMART_CYL_HI
			
			\irDriveRegs\bDriveHeadReg = $A0
			;If Not IsWindowsNT Then .bDriveHeadReg = .bDriveHeadReg Or (DriveNum And 1) * 16
			\irDriveRegs\bCommandReg = $B0;IDE_EXECUTE_SMART_FUNCTION
			\bDriveNumber = CurrentDrive
		EndWith
		ReadAttributesCmd = DeviceIoControl_(hdh, #DFP_RECEIVE_DRIVE_DATA, @bin, SizeOf(SENDCMDINPARAMS), @bArrOut(), 528, @cbBytesReturned, 0)
	Else
		Dim buffer.b(SizeOf(SRB_IO_CONTROL) + SizeOf(SENDCMDOUTPARAMS) + #SCSI_MINIPORT_BUFFER_SIZE)
		*p.SRB_IO_CONTROL      = @buffer()
		*pin.SENDCMDINPARAMS   = @buffer() + SizeOf(SRB_IO_CONTROL)
		*pout.SENDCMDOUTPARAMS = *pin
		
		With *p
			\HeaderLength = SizeOf(SRB_IO_CONTROL)
			\Timeout = 2
			\Length = SizeOf(SENDCMDOUTPARAMS) + #SCSI_MINIPORT_BUFFER_SIZE
			\ControlCode = $1b0503
			CopyMemory(@"SCSIDISK", @\Signature, 8)
		EndWith
		With *pin
			\irDriveRegs\bFeaturesReg	= $d1;command
			\irDriveRegs\bSectorCountReg	= 1
			\irDriveRegs\bSectorNumberReg	= 1
			\irDriveRegs\bCylLowReg		= $4f;#SMART_CYL_LOW
			\irDriveRegs\bCylHighReg	= $c2;#SMART_CYL_HI
			\irDriveRegs\bCommandReg	= $b0;#SMART_CMD
			\cBufferSize			= #SCSI_MINIPORT_BUFFER_SIZE
			\bDriveNumber			= SCSITargetID
		EndWith
		bRet = DeviceIoControl_(hdh, #IOCTL_SCSI_MINIPORT, @buffer(), SizeOf(SRB_IO_CONTROL) + SizeOf(SENDCMDINPARAMS) - 1, @buffer(), SizeOf(SRB_IO_CONTROL) + SizeOf(SENDCMDOUTPARAMS) + #SCSI_MINIPORT_BUFFER_SIZE, @dummy.l, #Null)
		CopyMemory(@buffer() + SizeOf(SRB_IO_CONTROL),@bArrOut(), SizeOf(SENDCMDOUTPARAMS))
	EndIf
  For i=0 To 29
  	If bArrOut(18 + i * 12) > 0
  		For j.l=0 To di(HDDCount)\NumAttributes
  			If bArrOut(18 + i * 12) = di(HDDCount)\Attributes[j]\AttrID
  				di(HDDCount)\Attributes[j]\AttrThreshold = bArrOut(19 + i * 12)
  			EndIf
  		Next
  	EndIf
  Next
EndProcedure

Procedure.s DiskStatus()
error.l
caution.l
flagUnknown.l = 1
For j = 0 To di(HDDCount)\NumAttributes-1
	If di(HDDCount)\Attributes[j]\AttrID <> $BE And di(HDDCount)\Attributes[j]\AttrThreshold <> 0 And di(HDDCount)\Attributes[j]\AttrValue <= di(HDDCount)\Attributes[J]\AttrThreshold
		error+1
	EndIf
	Select di(HDDCount)\Attributes[j]\AttrID
;		Case 5: ;;  Reallocated Sectors Count
;; 		Case 0xC4: ;  Reallocation Event Count
;		Case $C5:; ;  Current Pending Sector Count
;		Case $C6: ;;  Off-Line Scan Uncorrectable Sector Count
		Case 5, $C4, $C5, $C6
			If di(HDDCount)\Attributes[j]\AttrRaw & $00FFFFFFFF = $FFFFFFFF
				flagUnknown = 0
			Else
				caution + di(HDDCount)\Attributes[j]\AttrRaw & $FF + (di(HDDCount)\Attributes[j]\AttrRaw >> 8) & $FF
				flagUnknown = 0
			EndIf
	EndSelect
Next

	If error > 0
		ProcedureReturn "Bad"
	ElseIf flagUnknown = 1
		ProcedureReturn "Unknown"
	ElseIf caution > 0
		ProcedureReturn "Attention"
	Else
		ProcedureReturn "Good"
	EndIf

EndProcedure

Procedure.l HDDInfo(CurrentDrive.l, SCSIPort.l, SCSITargetID.l)
	If CheckSmartEnabled(CurrentDrive,SCSIPort, SCSITargetID)
		If CurrentDrive >= 0
			Dim bout.b(527)
			With bin
	  	      \cBufferSize = 512 ;IDENTIFY_BUFFER_SIZE
	  	      \irDriveRegs\bFeaturesReg = 0
	  	      \irDriveRegs\bSectorCountReg = 1
	         \irDriveRegs\bSectorNumberReg = 1
	         \irDriveRegs\bCylLowReg = 0
	         \irDriveRegs\bCylHighReg = 0
	         \irDriveRegs\bDriveHeadReg = $A0
	         ;If Not IsWindowsNT Then .bDriveHeadReg = .bDriveHeadReg Or (DriveNum And 1) * 16
	         \irDriveRegs\bCommandReg = $EC;CByte(IDCmd)
         
           	\bDriveNumber = CurrentDrive
          EndWith
         Result=DeviceIoControl_(hdh, #DFP_RECEIVE_DRIVE_DATA, @bin, SizeOf(SENDCMDINPARAMS), @bout(), 528,@dummy,0)
         CopyMemory(@bout(16),@idsec,512)
      Else
      	Dim buffer.b(SizeOf(SRB_IO_CONTROL) + SizeOf(SENDCMDOUTPARAMS) + #SCSI_MINIPORT_BUFFER_SIZE)
			*p.SRB_IO_CONTROL      = @buffer()
			*pin.SENDCMDINPARAMS   = @buffer() + SizeOf(SRB_IO_CONTROL)
			*pout.SENDCMDOUTPARAMS = *pin
			With *p
				\HeaderLength = SizeOf(SRB_IO_CONTROL)
				\Timeout = 2
				\Length = SizeOf(SENDCMDOUTPARAMS) + #SCSI_MINIPORT_BUFFER_SIZE
				\ControlCode = $1B0501
				CopyMemory(@"SCSIDISK", @\Signature, 8)
			EndWith
			With *pin
				\irDriveRegs\bCommandReg	= $ec;#SMART_CMD
				\bDriveNumber			= SCSITargetID
			EndWith
			bRet = DeviceIoControl_(hdh, #IOCTL_SCSI_MINIPORT, @buffer(), SizeOf(SRB_IO_CONTROL) + SizeOf(SENDCMDINPARAMS) - 1, @buffer(), SizeOf(SRB_IO_CONTROL) + SizeOf(SENDCMDOUTPARAMS) + #SCSI_MINIPORT_BUFFER_SIZE, @dummy.l, #Null)
			CopyMemory(@buffer() + SizeOf(SRB_IO_CONTROL)+16,@idsec, SizeOf(SENDCMDOUTPARAMS))
		EndIf
		If dummy>0
			HDDCount + 1
			If HDDCount > 1:ReDim di.DriveInfo(HDDCount): EndIf
			di(HDDCount)\SerialNumber =Trim(ChangeHighLowByte(PeekS(@idsec\SerialNumber[0],20)))
			di(HDDCount)\Model = Trim(ChangeHighLowByte(PeekS(@idsec\ModelNumber[0],40)))
			di(HDDCount)\Family = DiskFamily(di(HDDCount)\Model)
			di(HDDCount)\FirmWare = Trim(ChangeHighLowByte(PeekS(@idsec\FirmwareRev[0],8)))
			di(HDDCount)\BufferSize = Str(idsec\BufferSize / 2) + " KB"; * 512 / 1024 in KBs.
			di(HDDCount)\ECCBytes = Str(idsec\ECCSize) + " bytes"
			di(HDDCount)\LBASectors = FormatByteSize(idsec\MaxUserLBA)
			di(HDDCount)\CurTransferMode = CurrentTransferMode()
			di(HDDCount)\MaxTransferMode = MaximumTransferMode()
			If idsec\SerialAtaCapabilities <>0 And SerialAtaCapabilities <> $FFFF
				di(HDDCount)\InterfaceType = "Serial ATA"
			Else
				di(HDDCount)\InterfaceType = "Parallel ATA"
			EndIf
			di(HDDCount)\Standard = GetATAMajorVersion()
			If idsec\MaxUserLBA > 0
				di(HDDCount)\TheoriticalCapacity = c2str(idsec\MaxUserLba * 512 / 1000000000,2) + " GB"
				di(HDDCount)\RealCapacity = c2str(idsec\MaxUserLba * 512 / (1024*1024*1024),2) + " GB"
			ElseIf idsec\TotalAddressableSectors > 0
				di(HDDCount)\TheoriticalCapacity = c2str(idsec\TotalAddressableSectors * 512 / 1000000000,2) + " GB"
				di(HDDCount)\RealCapacity = c2str(idsec\TotalAddressableSectors * 512 / (1024*1024*1024),2) + " GB"
			Else
				di(HDDCount)\TheoriticalCapacity = "Not Available"
				di(HDDCount)\RealCapacity = "Not Available"
			EndIf
			If ATAVersion >= 3 And idsec\CommandSetSupported1 & 1
				di(HDDCount)\Flags\SMART = "YES"
			Else
				di(HDDCount)\Flags\SMART = "NO"
			EndIf
			If ATAVersion >= 5 And idsec\CommandSetSupported2 & (1 << 10)
				di(HDDCount)\Flags\LBA48 = "YES"
			Else
				di(HDDCount)\Flags\LBA48 = "NO"
			EndIf
			If ATAVersion >= 5 And idsec\CommandSetSupported2 & (1 << 9)
				di(HDDCount)\Flags\AAM = "YES"
			Else
				di(HDDCount)\Flags\AAM = "NO"
			EndIf
			If ATAVersion >= 6 And idsec\SerialAtaCapabilities & (1 << 8)
				di(HDDCount)\Flags\NCQ = "YES"
			Else
				di(HDDCount)\Flags\NCQ = "NO"
			EndIf
			If ATAVersion >= 7 And idsec\NvCacheCapabilities & 1
				di(HDDCount)\Flags\NVCache = "YES"
			Else
				di(HDDCount)\Flags\NVCache = "NO"
			EndIf
			ReadAttributes(CurrentDrive, SCSITargetID)
			ReadThresholds(CurrentDrive, SCSITargetID)
			If di(HDDCount)\Temperature = "": di(HDDCount)\Temperature = "Not Available": EndIf
			di(HDDCount)\DiskStatus = DiskStatus()
			ProcedureReturn 1
		Else
			ProcedureReturn 0
		EndIf
	Else
		ProcedureReturn 0
	EndIf
;EndIf
EndProcedure

For i=0 To 5
	HDDInfo(i,-1,-1)
Next
For i=0 To 3
	For ii=0 To 3
		HDDInfo(-1,i,ii)
	Next
Next

If OpenWindow(0, 100, 200, 500, 620, "Hard Disk Info", #PB_Window_SystemMenu | #PB_Window_MinimizeGadget | #PB_Window_ScreenCentered)
If CreateGadgetList(WindowID(0))   
 ListIconGadget(0,5,40,490,260,"Item",160,#PB_ListIcon_GridLines|#PB_ListIcon_FullRowSelect)
 AddGadgetColumn(0,1,"Data",300)
 ListIconGadget(1,5,310,490,300,"ID",40,#PB_ListIcon_GridLines|#PB_ListIcon_FullRowSelect)
 AddGadgetColumn(1,1,"Name",210)
 AddGadgetColumn(1,2,"Current",50)
 AddGadgetColumn(1,3,"Worst",50)
 AddGadgetColumn(1,4,"Threshold",50)
 AddGadgetColumn(1,5,"Raw",80)
 ComboBoxGadget(2, 5, 10, 300, 100)
 TextGadget(3,320,14,150,20,"<-- Please select a drive.")
EndIf

For i=0 To HDDCount
	AddGadgetItem(2,-1,di(i)\Model)
Next

  Repeat
    EventID = WaitWindowEvent()
    If EventID = #PB_Event_CloseWindow
      Quit = 1
    ElseIf EventID = #PB_Event_Gadget
    	If EventGadget() = 2
      	If CurrentHDD <> GetGadgetState(2)
				CurrentHDD = GetGadgetState(2)
		    	If CurrentHDD < 0: CurrentHDD = 0: EndIf
				SetGadgetState(2, CurrentHDD)
				AddGadgetItem(0,-1,"Model"+Chr(10)+di(CurrentHDD)\Model)
				AddGadgetItem(0,-1,"Family"+Chr(10)+di(CurrentHDD)\Family)
				AddGadgetItem(0,-1,"Serial Number"+Chr(10)+di(CurrentHDD)\SerialNumber)
				AddGadgetItem(0,-1,"FirmWare"+Chr(10)+di(CurrentHDD)\FirmWare)
				AddGadgetItem(0,-1,"Buffer Size"+Chr(10)+di(CurrentHDD)\BufferSize)
				AddGadgetItem(0,-1,"ECC Bytes"+Chr(10)+di(CurrentHDD)\ECCBytes)
				AddGadgetItem(0,-1,"LBA Sectors"+Chr(10)+di(CurrentHDD)\LBASectors)
				AddGadgetItem(0,-1,"Theor Capacity"+Chr(10)+di(CurrentHDD)\TheoriticalCapacity)
				AddGadgetItem(0,-1,"Real Capacity"+Chr(10)+di(CurrentHDD)\RealCapacity)
				AddGadgetItem(0,-1,"Temperature"+Chr(10)+di(CurrentHDD)\Temperature)
				AddGadgetItem(0,-1,"Cur Transfer Mode"+Chr(10)+di(CurrentHDD)\CurTransferMode)
				AddGadgetItem(0,-1,"Max Transfer Mode"+Chr(10)+di(CurrentHDD)\MaxTransferMode)
				AddGadgetItem(0,-1,"Interface Type"+Chr(10)+di(CurrentHDD)\InterfaceType)
				AddGadgetItem(0,-1,"Standard"+Chr(10)+di(CurrentHDD)\Standard)
				AddGadgetItem(0,-1,"Flags")
				AddGadgetItem(0,-1,"SMART"+Chr(10)+di(CurrentHDD)\Flags\SMART)
				AddGadgetItem(0,-1,"LBA48"+Chr(10)+di(CurrentHDD)\Flags\LBA48)
				AddGadgetItem(0,-1,"AAM"+Chr(10)+di(CurrentHDD)\Flags\AAM)
				AddGadgetItem(0,-1,"NCQ"+Chr(10)+di(CurrentHDD)\Flags\NCQ)
				AddGadgetItem(0,-1,"NVCache"+Chr(10)+di(CurrentHDD)\Flags\NVCache)
				
				For i=0 To di(CurrentHDD)\NumAttributes-1
				If di(CurrentHDD)\Attributes[i]\AttrName="": Break: EndIf
				AddGadgetItem(1,-1,Str(di(CurrentHDD)\Attributes[i]\AttrID) + Chr(10) + di(CurrentHDD)\Attributes[i]\AttrName + Chr(10) + Str(di(CurrentHDD)\Attributes[i]\AttrValue) + Chr(10) + Str(di(CurrentHDD)\Attributes[i]\AttrWorstValue) + Chr(10) + Str(di(CurrentHDD)\Attributes[i]\AttrThreshold) + Chr(10) + RSet(Hex(di(CurrentHDD)\Attributes[i]\AttrRaw),12,"0"))
				Next
			EndIf
		EndIf
    EndIf

  Until Quit = 1
  
EndIf

End 

; IDE Options = PureBasic 4.20 (Windows - x86)
; CursorPosition = 745
; FirstLine = 733
; Folding = ---
; EnableXP
; EnableAdmin