Procedure.s DiskFamily(Code.s)
Protected Model.s = ""
Restore HDD_CODES
Repeat
	Read HDDModel.s
	If HDDModel = ""
		Break
	EndIf
	Read HDDCodeExpression.s
	If CreateRegularExpression(0, HDDCodeExpression)
		If MatchRegularExpression(0, Code)
			FreeRegularExpression(0)
			Model = HDDModel
			Break
		EndIf
		FreeRegularExpression(0)
	EndIf
ForEver
ProcedureReturn Model
EndProcedure

DataSection
	HDD_CODES:
		Data.s "ExcelStor J240", "^ExcelStor Technology J240$"
		Data.s "ExcelStor J340", "^ExcelStor Technology J340$"
		Data.s "ExcelStor J360", "^ExcelStor Technology J360$"
		Data.s "ExcelStor J680", "^ExcelStor Technology J680$"
		Data.s "ExcelStor J880", "^ExcelStor Technology J880$"
		Data.s "IBM Deskstar 60GXP series", "(IBM-|Hitachi )?IC35L0[12346]0AVER07"
		Data.s "IBM Deskstar 40GV & 75GXP series", "(IBM-)?DTLA-30[57]0[123467][05]"
		Data.s "Fujitsu M1623TAU", "^FUJITSU M1623TAU$"
		Data.s "Fujitsu MHM2200AT", "^FUJITSU MHM2200AT"
		Data.s "Fujitsu MHM2150AT", "^FUJITSU MHM2150AT"
		Data.s "Fujitsu MHM2100AT", "^FUJITSU MHM2100AT"
		Data.s "Fujitsu MHM2060AT", "^FUJITSU MHM2060AT"
		Data.s "Fujitsu MHG series", "^FUJITSU MHG2...ATU?"
		Data.s "Fujitsu MHH series", "^FUJITSU MHH2...ATU?"
		Data.s "Fujitsu MHJ series", "^FUJITSU MHJ2...ATU?"
		Data.s "Fujitsu MHK series", "^FUJITSU MHK2...ATU?"
		Data.s "Fujitsu MHL2300AT", "^FUJITSU MHL2300AT$"
		Data.s "Fujitsu MHN series", "^FUJITSU MHN2...AT$"
		Data.s "Fujitsu MHR2020AT", "^FUJITSU MHR2020AT$"
		Data.s "Fujitsu MHR2040AT", "^FUJITSU MHR2040AT$"
		Data.s "Fujitsu MHSxxxxAT family", "^FUJITSU MHS20[6432]0AT(  .)?$"
		Data.s "Fujitsu MHT series", "^FUJITSU MHT2...(AH|AS|AT|BH)U?"
		Data.s "Fujitsu MHU series", "^FUJITSU MHU2...ATU?"
		Data.s "Fujitsu MHV series", "^FUJITSU MHV2...(AH|AS|AT|BH|BS|BT)"
		Data.s "Fujitsu MPA..MPG series", "^FUJITSU MP[A-G]3...A[HTEV]U?"
		Data.s "Fujitsu MHW2 BH", "^FUJITSU MHW2(04|06|08|10|12|16)0BH$"
		Data.s "Samsung SV4012H", "^SAMSUNG SV4012H$"
		Data.s "Samsung SV0412H", "^SAMSUNG SV0412H$"
		Data.s "Samsung SV1204H", "^SAMSUNG SV1204H$"
		Data.s "Samsung SV0322A", "^SAMSUNG SV0322A$"
		Data.s "Samsung SP40A2H with RR100-07 firmware",     "^SAMSUNG SP40A2H$"
		Data.s "Samsung SP8004H with QW100-61 firmware", "^SAMSUNG SP8004H$"
		Data.s "Samsung SpinPoint T133 series", "^SAMSUNG HD(250KD|(30[01]|320|40[01])L[DJ])$"
		Data.s "Samsung SpinPoint T166 series", "^SAMSUNG HD(080G|160H|32[01]K|403L|50[01]L)J$"
		Data.s "Samsung SpinPoint P120 series", "^SAMSUNG SP(16[01]3|2[05][01]4)[CN]$"
		Data.s "Samsung SpinPoint P80 SD series", "^SAMSUNG HD(080H|120I|160J)J$"
		Data.s "Samsung SpinPoint P80 series", "^SAMSUNG SP(0451|08[0124]2|12[0145]3|16[0145]4)[CN]$"
		Data.s "Maxtor Fireball 541DX family", "^Maxtor 2B0(0[468]|1[05]|20)H1$"
		Data.s "Maxtor Fireball 3 family", "^Maxtor 2F0[234]0[JL]0$"
		Data.s "Maxtor DiamondMax 2160 Ultra ATA family", "^Maxtor 8(2160D2|3228D3|3240D3|4320D4|6480D6|8400D8|8455D8)$"
		Data.s "Maxtor DiamondMax 2880 Ultra ATA family", "^Maxtor 9(0510D4|0576D4|0648D5|0720D5|0840D6|0845D6|0864D6|1008D7|1080D8|1152D8)$"
		Data.s "Maxtor DiamondMax 3400 Ultra ATA family", "^Maxtor 9(1(360|350|202)D8|1190D7|10[12]0D6|0840D5|06[48]0D4|0510D3|1(350|202)E8|1010E6|0840E5|0640E4)$"
		Data.s "Maxtor DiamondMax D540X-4G family", "^Maxtor 4G(120J6|160J[68])$"
		Data.s "Maxtor DiamondMax D540X-4K family", "^MAXTOR 4K(020H1|040H2|060H3|080H4)$"
		Data.s "Maxtor DiamondMax Plus D740X family", "^MAXTOR 6L0(20[JL]1|40[JL]2|60[JL]3|80[JL]4)$"
		Data.s "Maxtor DiamondMax Plus 5120 Ultra ATA 33 family", "^Maxtor 9(0512D2|0680D3|0750D3|0913D4|1024D4|1360D6|1536D6|1792D7|2048D8)$"
		Data.s "Maxtor DiamondMax Plus 6800 Ultra ATA 66 family", "^Maxtor 9(2732U8|2390U7|2049U6|1707U5|1366U4|1024U3|0845U3|0683U2)$"
		Data.s "Maxtor DiamondMax D540X-4D", "^Maxtor 4D0(20H1|40H2|60H3|80H4)$"
		Data.s "Maxtor DiamondMax 16 family", "^Maxtor 4(R0[68]0[JL]0|R1[26]0L0|A160J0|R120L4)$"
		Data.s "Maxtor DiamondMax 4320 Ultra ATA family", "^Maxtor (91728D8|91512D7|91303D6|91080D5|90845D4|90645D3|90648D[34]|90432D2)$"
		Data.s "Maxtor DiamondMax 17 VL family", "^Maxtor 9(0431U1|0641U2|0871U2|1301U3|1741U4)$"
		Data.s "Maxtor DiamondMax 20 VL family", "^Maxtor (94091U8|93071U6|92561U5|92041U4|91731U4|91531U3|91361U3|91021U2|90841U2|90651U2)$"
		Data.s "Maxtor DiamondMax VL 30 family", "^Maxtor (33073U4|32049U3|31536U2|30768U1)$"
		Data.s "Maxtor DiamondMax 36 family", "^Maxtor (93652U8|92739U6|91826U4|91369U3|90913U2|90845U2|90435U1)$"
		Data.s "Maxtor DiamondMax 40 ATA 66 series", "^Maxtor 9(0684U2|1024U2|1362U3|1536U3|2049U4|2562U5|3073U6|4098U8)$"
		Data.s "Maxtor DiamondMax Plus 40 series (Ultra ATA 66 and Ultra ATA 100)", "^Maxtor (54098[UH]8|53073[UH]6|52732[UH]6|52049[UH]4|51536[UH]3|51369[UH]3|51024[UH]2)$"
		Data.s "Maxtor DiamondMax 40 VL Ultra ATA 100 series", "^Maxtor 3(1024H1|1535H2|2049H2|3073H3|4098H4)( B)?$"
		Data.s "Maxtor DiamondMax Plus 45 Ulta ATA 100 family", "^Maxtor 5(4610H6|4098H6|3073H4|2049H3|1536H2|1369H2|1023H2)$"
		Data.s "Maxtor DiamondMax 60 ATA 66 family", "^Maxtor 9(1023U2|1536U2|2049U3|2305U3|3073U4|4610U6|6147U8)$"
		Data.s "Maxtor DiamondMax 60 ATA 100 family", "^Maxtor 9(1023H2|1536H2|2049H3|2305H3|3073H4|4610H6|6147H8)$"
		Data.s "Maxtor DiamondMax Plus 60 family", "^Maxtor 5T0(60H6|40H4|30H3|20H2|10H1)$"
		Data.s "Maxtor DiamondMax 80 family", "^Maxtor (98196H8|96147H6)$"
		Data.s "Maxtor DiamondMax 536DX family", "^Maxtor 4W(100H6|080H6|060H4|040H3|030H2)$"
		Data.s "Maxtor DiamondMax Plus 8 family", "^Maxtor 6(E0[234]|K04)0L0$"
		Data.s "Maxtor DiamondMax 10 family (ATA/133 and SATA/150)", "^Maxtor 6(B(30|25|20|16|12|08)0[MPRS]|L(080[MLP]|(100|120)[MP]|160[MP]|200[MPRS]|250[RS]|300[RS]))0$"
		Data.s "Maxtor DiamondMax 10 family (SATA/300)", "^Maxtor 6V(080E|160E|200E|250F|300F|320F)0$"
		Data.s "Maxtor DiamondMax Plus 9 family", "^Maxtor 6Y((060|080|120|160)L0|(060|080|120|160|200|250)P0|(060|080|120|160|200|250)M0)$"
		Data.s "Maxtor DiamondMax 11 family", "^Maxtor 6H[45]00[FR]0$"
		Data.s "Maxtor DiamondMax 17", "^Maxtor 6G(080L|160[PE])0$"
		Data.s "Seagate Maxtor DiamondMax 20", "^MAXTOR STM3(40|80|160)[28]1[12]0?AS?$"
		Data.s "Seagate Maxtor DiamondMax 21", "^MAXTOR STM3(250|320)820AS?$"
		Data.s "Maxtor MaXLine Plus II", "^Maxtor 7Y250[PM]0$"
		Data.s "Maxtor MaXLine II family", "^Maxtor [45]A(25|30|32)0[JN]0$"
		Data.s "Maxtor MaXLine III family (ATA/133 and SATA/150)", "^Maxtor 7L(25|30)0[SR]0$"
		Data.s "Maxtor MaXLine III family (SATA/300)", "^Maxtor 7V(25|30)0F0$"
		Data.s "Maxtor MaXLine Pro 500 family", "^Maxtor 7H500F0$"
		Data.s "Hitachi DK14FA-20B", "^HITACHI_DK14FA-20B$"
		Data.s "Hitachi Travelstar DK23XX/DK23XXB series", "^HITACHI_DK23..-..B?$"
		Data.s "Hitachi Endurastar J4K20/N4K20", "^(HITACHI_DK23FA-20J|HTA422020F9AT[JN]0)$"
		Data.s "IBM Deskstar 14GXP and 16GP series", "^IBM-DTTA-3(7101|7129|7144|5032|5043|5064|5084|5101|5129|5168)0$"
		Data.s "IBM Deskstar 25GP and 22GXP family", "^IBM-DJNA-3(5(101|152|203|250)|7(091|135|180|220))0$"
		Data.s "IBM Travelstar 4GT family", "^IBM-DTCA-2(324|409)0$"
		Data.s "IBM Travelstar 25GS, 18GT, and 12GN family", "^IBM-DARA-2(25|18|15|12|09|06)000$"
		Data.s "IBM Travelstar 48GH, 30GN, and 15GN family", "^(IBM-|Hitachi )?IC25(T048ATDA05|N0(30|20|15|12|10|07|06|05)ATDA04)-.$"
		Data.s "IBM Travelstar 32GH, 30GT, and 20GN family", "^IBM-DJSA-2(32|30|20|10|05)$"
		Data.s "IBM Travelstar 4GN family", "^IBM-DKLA-2(216|324|432)0$"
		Data.s "IBM Deskstar 37GP and 34GXP family", "^IBM-DPTA-3(5(375|300|225|150)|7(342|273|205|136))0$"
		Data.s "IBM/Hitachi Travelstar 60GH and 40GN family", "^(IBM-|Hitachi )?IC25(T060ATC[SX]05|N0[4321]0ATC[SX]04)-.$"
		Data.s "IBM/Hitachi Travelstar 40GNX family", "^(IBM-|Hitachi )?IC25N0[42]0ATC[SX]05-.$"
		Data.s "Hitachi Travelstar 80GN family", "^(Hitachi )?IC25N0[23468]0ATMR04-.$"
		Data.s "Hitachi Travelstar 4K40", "^(Hitachi )?HTS4240[234]0M9AT00$"
		Data.s "Hitachi Travelstar 5K80 family", "^(Hitachi )?HTS5480[8642]0M9AT00$"
		Data.s "Hitachi Travelstar 5K100 series", "^(Hitachi )?HTS5410[1864]0G9(AT|SA)00$"
		Data.s "Hitachi Travelstar E5K100 series", "^(Hitachi )?HTE541040G9(AT|SA)00$"
		Data.s "Hitachi Travelstar 5K120", "^(Hitachi )?HTS5412(60|80|10|12)H9(AT|SA)00$"
		Data.s "Hitachi Travelstar 5K160 series", "^(Hitachi )?HTS5416([468]0|1[26])J9(AT|SA)00$"
		Data.s "Hitachi Travelstar 7K60", "^(Hitachi )?HTS726060M9AT00$"
		Data.s "Hitachi Travelstar E7K60", "^(Hitachi )?HTE7260[46]0M9AT00$"
		Data.s "Hitachi Travelstar 7K100", "^(Hitachi )?HTS7210[168]0G9(AT|SA)00$"
		Data.s "Hitachi Travelstar E7K100", "^(Hitachi )?HTE7210[168]0G9(AT|SA)00$"
		Data.s "Hitachi Travelstar 7K200", "^(Hitachi )?HTS7220(80|10|12|16|20)K9(A3|SA)00$"
		Data.s "IBM/Hitachi Deskstar 120GXP family", "^(IBM-)?IC35L((020|040|060|080|120)AVVA|0[24]0AVVN)07-[01]$"
		Data.s "IBM/Hitachi Deskstar GXP-180 family", "^(IBM-)?IC35L(030|060|090|120|180)AVV207-[01]$"
		Data.s "IBM Travelstar 14GS", "^IBM-DCYA-214000$"
		Data.s "IBM Travelstar 4LP", "^IBM-DTNA-2(180|216)0$"
		Data.s "Hitachi Deskstar 7K80 series", "^(Hitachi )?HDS7280([48]0PLAT20|(40)?PLA320|80PLA380)$"
		Data.s "Hitachi Deskstar 7K160", "^(Hitachi )?HDS7216(80|16)PLA[3T]80$"
		Data.s "Hitachi Deskstar 7K250 series", "^(Hitachi )?HDS7225((40|80|12|16)VLAT20|(12|16|25)VLAT80|(80|12|16|25)VLSA80)$"
		Data.s "Hitachi Deskstar T7K250 series", "^(Hitachi )?HDT7225((25|20|16)DLA(T80|380))$"
		Data.s "Hitachi Deskstar 7K400 series", "^(Hitachi )?HDS724040KL(AT|SA)80$"
		Data.s "Hitachi Deskstar 7K500 series", "^(Hitachi )?HDS725050KLA(360|T80)$"
		Data.s "Hitachi Deskstar T7K500", "^(Hitachi )?HDT7250(25|32|40|50)VLA(360|380|T80)$"
		Data.s "Hitachi Deskstar 7K1000", "^(Hitachi )?HDS7210(75|10)KLA330$"
		Data.s "Hitachi Ultrastar 7K1000", "^(Hitachi )?HUA7210(50|75|10)KLA330$"
		Data.s "Toshiba 2.5'' HDD series (30-60 GB)", "^TOSHIBA MK((6034|4032)GSX|(6034|4032)GAX|(6026|4026|4019|3019)GAXB?|(6025|6021|4025|4021|4018|3025|3021|3018)GAS|(4036|3029)GACE?|(4018|3017)GAP)$"
		Data.s "Toshiba 2.5'' HDD series (80 GB And above)", "^TOSHIBA MK(80(25GAS|26GAX|32GAX|32GSX)|10(31GAS|32GAX)|12(33GAS|34G[As]X)|2035GSS)$"
		Data.s "Toshiba 1.8'' HDD series", "^TOSHIBA MK[23468]00[4-9]GA[HL]$"
		Data.s "Toshiba MK6022GAX", "^TOSHIBA MK6022GAX$"
		Data.s "Toshiba MK6409MAV", "^TOSHIBA MK6409MAV$"
		Data.s "Toshiba MK3019GAXB SUN30G", "^TOS MK3019GAXB SUN30G$"
		Data.s "Toshiba MK2016GAP", "^TOSHIBA MK2016GAP$"
		Data.s "Toshiba MK2017GAP", "^TOSHIBA MK2017GAP$"
		Data.s "Toshiba MK2018GAP", "^TOSHIBA MK2018GAP$"
		Data.s "Toshiba MK2018GAS", "^TOSHIBA MK2018GAS$"
		Data.s "Toshiba MK2023GAS", "^TOSHIBA MK2023GAS$"
		Data.s "Seagate Momentus family", "^ST9(20|28|40|48)11A$"
		Data.s "Seagate Momentus 42 family", "^ST9(2014|3015|4019)A$"
		Data.s "Seagate Momentus 4200.2 Series", "^ST9(100822|808210|60821|50212|402113|30219)A$"
		Data.s "Seagate Momentus 5400.2 series", "^ST9(808211|60822|408114|308110|120821|10082[34]|8823|6812|4813|3811)AS?$"
		Data.s "Seagate Momentus 5400.3", "^ST9(4081[45]|6081[35]|8081[15]|100828|120822|160821)AS?$"
		Data.s "Seagate Momentus 5400.3 ED", "^ST9(4081[45]|6081[35]|8081[15]|100828|120822|160821)AB$"
		Data.s "Seagate Momentus 7200.1 series", "^ST9(10021|80825|6023|4015)AS?$"
		Data.s "Seagate Momentus 7200.2", "^ST9(80813|100821|120823|160823|200420)ASG?$"
		Data.s "Seagate U Series X family", "^ST3(10014A(CE)?|20014A)$"
		Data.s "Seagate U7 family", "^ST3(30012|40012|60012|80022|120020)A$"
		Data.s "Seagate U Series 6 family", "^ST3(8002|6002|4081|3061|2041)0A$"
		Data.s "Seagate U Series 5 family", "^ST3(40823|30621|20413|15311|10211)A$"
		Data.s "Seagate U4 family", "^ST3(2112|4311|6421|8421)A$"
		Data.s "Seagate U8 family", "^ST3(8410|4313|17221|13021)A$"
		Data.s "Seagate U10 family", "^ST3(20423|15323|10212)A$"
		Data.s "Seagate Barracuda ATA II family", "^ST3(3063|2042|1532|1021)0A$"
		Data.s "Seagate Barracuda ATA III family", "^ST3(40824|30620|20414|15310|10215)A$"
		Data.s "Seagate Barracuda ATA IV family", "^ST3(20011|30011|40016|60021|80021)A$"
		Data.s "Seagate Barracuda ATA V family", "^ST3(12002(3A|4A|9A|3AS)|800(23A|15A|23AS)|60(015A|210A)|40017A)$"
		Data.s "Seagate Barracuda 5400.1", "^ST340015A$"
		Data.s "Seagate Barracuda 7200.7 and 7200.7 Plus family", "^ST3(200021A|200822AS?|16002[13]AS?|12002[26]AS?|1[26]082[78]AS|8001[13]AS?|80817AS|60014A|40111AS|40014AS?)$"
		Data.s "Seagate Barracuda 7200.8 family", "^ST3(400[68]32|300[68]31|250[68]23|200826)AS?$"
		Data.s "Seagate Barracuda 7200.9 family", "^ST3(402111?|80[28]110?|120[28]1[0134]|160[28]1[012]|200827|250[68]24|300[68]22|(320|400)[68]33|500[68](32|41))AS?$"
		Data.s "Seagate Barracuda 7200.10 family", "^ST3((80|160)[28]15|200820|250[34]10|(250|300|320|400)[68]20|500[68]30|750[68]40)AS?$"
		Data.s "Seagate Barracuda 7200.11", "^ST3(500[368]2|750[36]3|1000[36]4)0AS?$"
		Data.s "Seagate Barracuda ES", "^ST3(250[68]2|32062|40062|50063|75064)0NS$"
		Data.s "Seagate Medalist 17240", "^ST317240A$"
		Data.s "Seagate Medalist 13030", "^ST313030A$"
		Data.s "Seagate Medalist 10231", "^ST310231A$"
		Data.s "Seagate Medalist 8420", "^ST38420A$"
		Data.s "Seagate Medalist 4310", "^ST34310A$"
		Data.s "Seagate Medalist 17242", "^ST317242A$"
		Data.s "Seagate Medalist 13032", "^ST313032A$"
		Data.s "Seagate Medalist 10232", "^ST310232A$"
		Data.s "Seagate Medalist 8422", "^ST38422A$"
		Data.s "Seagate Medalist 4312", "^ST34312A$"
		Data.s "Seagate Medalist 2110", "^ST32110A$"
		Data.s "Seagate Medalist 3221", "^ST33221A$"
		Data.s "Seagate Medalist 4321", "^ST34321A$"
		Data.s "Seagate Medalist 6531", "^ST36531A$"
		Data.s "Seagate Medalist 8641", "^ST38641A$"
		Data.s "Seagate NL35 family", "^ST3(250623|250823|400632|400832|250824|250624|400633|400833|500641|500841)NS$"
		Data.s "Western Digital Protege", "^WDC WD([2468]00E|1[26]00A)B-.*$"
		Data.s "Western Digital Caviar family", "^WDC WD(2|3|4|6|8|10|12|16|18|20|25)00BB-.*$"
		Data.s "Western Digital Caviar AC12500", "^WDC AC12500.?"
		Data.s "Western Digital Caviar AC14300", "^WDC AC14300.?"
		Data.s "Western Digital Caviar AC23200", "^WDC AC23200.?"
		Data.s "Western Digital Caviar AC24300", "^WDC AC24300.?"
		Data.s "Western Digital Caviar AC25100", "^WDC AC25100.?"
		Data.s "Western Digital Caviar AC36400", "^WDC AC36400.?"
		Data.s "Western Digital Caviar AC38400", "^WDC AC38400.?"
		Data.s "Western Digital Caviar WDxxxAB series", "^WDC WD(3|4|6)00AB-.*$"
		Data.s "Western Digital Caviar WDxxxAA series", "^WDC WD...?AA(-.*)?$"
		Data.s "Western Digital Caviar WDxxxBA series", "^WDC WD...BA$"
		Data.s "Western Digital Caviar Serial ATA family", "^WDC WD(4|8|20|32)00BD-.*$"
		Data.s "Western Digital Caviar SE family", "^WDC WD((4|6|8|10|12|16|18|20|25|30|32|40|50)00(JB|PB|AAJB|AAKB))-.*$"
		Data.s "Western Digital Caviar SE Serial ATA family", "^WDC WD((4|8|12|16|20|25|32|40)00(JD|KD))-.*$"
		Data.s "Western Digital Caviar Second Generation Serial ATA family", "^WDC WD((8|12|16|20|25|30|32|40|50|75)00(JS|KS|AABS|AAJS|AAKS))-.*$"
		Data.s "Western Digital Caviar RE Serial ATA family", "^WDC WD((12|16|25|32|40|50|75)00(SD|YD|YR|YS|ABYS|AYYS))-.*$"
		Data.s "Western Digital Caviar RE EIDE family", "^WDC WD((12|16|25|32)00SB)-.*$"
		Data.s "Western Digital Raptor family", "^WDC WD((360|740|800)GD|(360|740|1500)ADFD)-.*$"
		Data.s "Western Digital Scorpio family", "^WDC WD((4|6|8|10|12|16|20|25)00(UE|VE|BEAS|BEVE|BEVS))-.*$"
		Data.s "Quantum BIGFOOT TS10.0A", "^QUANTUM BIGFOOT TS10.0A$"
		Data.s "Quantum FIREBALLlct15 20 And QUANTUM FIREBALLlct15 30", "^QUANTUM FIREBALLlct15 [123]0$"
		Data.s "Quantum FIREBALLlct20 series", "^QUANTUM FIREBALLlct20 [234]0$"
		Data.s "Quantum FIREBALL CX10.2A", "^QUANTUM FIREBALL CX10.2A$"
		Data.s "Quantum Fireball Plus LM series", "^QUANTUM FIREBALLP LM(10.2|15|20.5|30)$"
		Data.s "Quantum Fireball CR series", "^QUANTUM FIREBALL CR(4.3|8.4)A$"
		Data.s "Quantum FIREBALLP AS10.2, AS20.5, AS30.0, And AS40.0", "^QUANTUM FIREBALLP AS(10.2|20.5|30.0|40.0)$"
		Data.s "Quantum FIREBALL EX6.4A", "^QUANTUM FIREBALL EX6.4A$"
		Data.s "Quantum FIREBALL ST3.2A", "^QUANTUM FIREBALL ST(3.2|4.3)A$"
		Data.s "Quantum FIREBALL EX3.2A", "^QUANTUM FIREBALL EX3.2A$"
		Data.s "Quantum FIREBALLP KX27.3", "^QUANTUM FIREBALLP KX27.3$"
		Data.s "Quantum Fireball Plus KA series", "^QUANTUM FIREBALLP KA(9|10).1$"
		Data.s "Quantum Fireball SE series", "^QUANTUM FIREBALL SE4.3A$"
		Data.s ""	; Marks end of data
EndDataSection
; IDE Options = PureBasic 4.20 (Windows - x86)
; CursorPosition = 207
; FirstLine = 164
; Folding = -
; EnableXP
; EnableAdmin
; EnableOnError
; CurrentDirectory = F:\120GB\WInfo.exe\
; CompileSourceDirectory